<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cyhal__pwm_8c" kind="file" language="C++">
    <compoundname>cyhal_pwm.c</compoundname>
    <includes local="no">string.h</includes>
    <includes local="yes" refid="cyhal__clock_8h">cyhal_clock.h</includes>
    <includes local="yes" refid="cyhal__gpio_8h">cyhal_gpio.h</includes>
    <includes local="yes" refid="cyhal__hwmgr_8h">cyhal_hwmgr.h</includes>
    <includes local="yes" refid="cyhal__pwm_8h">cyhal_pwm.h</includes>
    <includes local="yes" refid="cyhal__syspm_8h">cyhal_syspm.h</includes>
    <includes local="yes" refid="cyhal__utils_8h">cyhal_utils.h</includes>
    <incdepgraph>
      <node id="300">
        <label>string.h</label>
      </node>
      <node id="299">
        <label>cyhal_pwm.c</label>
        <link refid="cyhal__pwm_8c" />
        <childnode refid="300" relation="include">
        </childnode>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="cyhal__pwm_8c_1ad3996c004e79e434ea6e869fd8be4f5f" kind="define" prot="public" static="no">
        <name>_CYHAL_PWM_MAX_WIDTH</name>
        <initializer>16</initializer>
        <briefdescription>
<para>group_hal_impl_pwm </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="71" column="10" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="71" />
      </memberdef>
      <memberdef id="cyhal__pwm_8c_1adfa76f2af138df6fae528722e5958ef7" kind="define" prot="public" static="no">
        <name>_CYHAL_PWM_MAX_DEAD_TIME_CYCLES</name>
        <initializer>255</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="73" column="10" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="73" />
      </memberdef>
      <memberdef id="cyhal__pwm_8c_1a482559d2169dab959685abfed15b5f46" kind="define" prot="public" static="no">
        <name>_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED</name>
        <initializer>(_VAL2FLD(TCPWM_CNT_TR_CTRL2_CC_MATCH_MODE, CY_TCPWM_PWM_TR_CTRL2_INVERT) | \
                                         _VAL2FLD(TCPWM_CNT_TR_CTRL2_OVERFLOW_MODE, CY_TCPWM_PWM_TR_CTRL2_CLEAR) | \
                                         _VAL2FLD(TCPWM_CNT_TR_CTRL2_UNDERFLOW_MODE, CY_TCPWM_PWM_TR_CTRL2_SET))</initializer>
        <briefdescription>
<para>The configuration of PWM output signal for Center and Asymmetric alignment with overflow and underflow swapped. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="83" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="83" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="cyhal__pwm_8c_1ad2ae551713feedbbcf4bd3d14538ab5b" kind="variable" mutable="no" prot="public" static="yes">
        <type>const uint32_t</type>
        <definition>const uint32_t _CYHAL_PWM_US_PER_SEC</definition>
        <argsstring />
        <name>_CYHAL_PWM_US_PER_SEC</name>
        <initializer>= 1000000u</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="74" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="74" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cyhal__pwm_8c_1ae80e8c3751c3590cccb326c8b018ea35" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>static cy_rslt_t _cyhal_pwm_convert_alignment</definition>
        <argsstring>(cyhal_pwm_alignment_t hal_alignment, uint32_t *pdl_alignment, bool swapped)</argsstring>
        <name>_cyhal_pwm_convert_alignment</name>
        <param>
          <type><ref kindref="member" refid="group__group__hal__pwm_1ga251111384b543a19975df63353203b51">cyhal_pwm_alignment_t</ref></type>
          <declname>hal_alignment</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>pdl_alignment</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>swapped</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="105" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="89" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="89" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cyhal__pwm_8c_1a97845d430af3a14de071bd78a80e2f95" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>static cy_rslt_t cyhal_pwm_set_period_and_compare</definition>
        <argsstring>(cyhal_pwm_t *obj, uint32_t period, uint32_t compare)</argsstring>
        <name>cyhal_pwm_set_period_and_compare</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>period</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>compare</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="144" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="107" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="107" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pwm_1gacbeddfe75ccc849d27bec32ce010eceb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pwm_init_adv</definition>
        <argsstring>(cyhal_pwm_t *obj, cyhal_gpio_t pin, cyhal_gpio_t pin_compl, cyhal_pwm_alignment_t pwm_alignment, bool continuous, uint32_t dead_time_us, bool invert, const cyhal_clock_t *clk)</argsstring>
        <name>cyhal_pwm_init_adv</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>compl_pin</declname>
          <defname>pin_compl</defname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__pwm_1ga251111384b543a19975df63353203b51">cyhal_pwm_alignment_t</ref></type>
          <declname>pwm_alignment</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>continuous</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>dead_time_us</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>invert</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref> *</type>
          <declname>clk</declname>
        </param>
        <briefdescription>
<para>Initialize the PWM out peripheral and configure the pin. </para>        </briefdescription>
        <detaileddescription>
<para>This is similar to the <ref kindref="member" refid="group__group__hal__pwm_1ga54a93c541bdbb3fce066a2af00d8b67f">cyhal_pwm_init()</ref> but provides additional setup options. <linebreak />
 See <ref kindref="member" refid="group__group__hal__pwm_1subsection_pwm_snippet_3">Snippet 3: Advanced PWM output to pin</ref>.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a PWM object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin</parametername>
</parameternamelist>
<parameterdescription>
<para>The PWM pin to initialize. This pin is required, it cannot be <ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__04__80__tqfp_1gga43c4aa9a5556b7386cb604f0ab3b242ca3dbd1016ea99d087d747530418b89a01">NC</ref> (No Connect). </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">compl_pin</parametername>
</parameternamelist>
<parameterdescription>
<para>An optional, additional inverted output pin. <linebreak />
 If supplied, this must be connected to the same PWM instance as <bold>pin</bold>, for PSoC 6 see <ref kindref="member" refid="group__group__hal__impl__pwm_1section_hal_impl_pwm_compl_pins">Complementary PWM output</ref>.<linebreak />
 If this output is not needed, use <ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__04__80__tqfp_1gga43c4aa9a5556b7386cb604f0ab3b242ca3dbd1016ea99d087d747530418b89a01">NC</ref> (No Connect). </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pwm_alignment</parametername>
</parameternamelist>
<parameterdescription>
<para>PWM alignment: left, right, or center. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">continuous</parametername>
</parameternamelist>
<parameterdescription>
<para>PWM run type: continuous (true) or one shot (false). </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dead_time_us</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of micro-seconds for dead time. This is only meaningful if both <bold>pin</bold> and <bold>compl_pin</bold> are provided. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">invert</parametername>
</parameternamelist>
<parameterdescription>
<para>An option for the user to invert the PWM output </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">clk</parametername>
</parameternamelist>
<parameterdescription>
<para>An optional, pre-allocated clock to use, if NULL a new clock will be allocated. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request</para></simplesect>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;In some cases, it is possible to use a pin designated for non-inverting output as an inverting output and vice versa. Whether this is possible is dependent on the HAL implementation and operating mode. See the implementation specific documentation for details. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="305" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="146" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="146" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pwm_1ga3e4e8aa7a73d02a15dcf386c335b1598" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_pwm_free</definition>
        <argsstring>(cyhal_pwm_t *obj)</argsstring>
        <name>cyhal_pwm_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Deinitialize the PWM object. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PWM object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="313" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="307" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="307" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pwm_1gaab0dc18eb0b1c51623df07f2c275a578" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pwm_set_period</definition>
        <argsstring>(cyhal_pwm_t *obj, uint32_t period_us, uint32_t pulse_width_us)</argsstring>
        <name>cyhal_pwm_set_period</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>period_us</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>pulse_width_us</declname>
        </param>
        <briefdescription>
<para>Set the number of microseconds for the PWM period &amp; pulse width. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PWM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">period_us</parametername>
</parameternamelist>
<parameterdescription>
<para>The period in microseconds </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pulse_width_us</parametername>
</parameternamelist>
<parameterdescription>
<para>The pulse width in microseconds </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the period request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="321" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="315" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="315" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pwm_1ga9c468081d85d103ec10f9feeffe416ce" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pwm_set_duty_cycle</definition>
        <argsstring>(cyhal_pwm_t *obj, float duty_cycle, uint32_t frequencyhal_hz)</argsstring>
        <name>cyhal_pwm_set_duty_cycle</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>float</type>
          <declname>duty_cycle</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>frequencyhal_hz</declname>
        </param>
        <briefdescription>
<para>Set the PWM duty cycle and frequency. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PWM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">duty_cycle</parametername>
</parameternamelist>
<parameterdescription>
<para>The percentage of time the output is high </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">frequencyhal_hz</parametername>
</parameternamelist>
<parameterdescription>
<para>The frequency of the PWM in Hz </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the duty cycle request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="331" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="323" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="323" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pwm_1ga95006bcc5841e610719433660365e3e2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pwm_start</definition>
        <argsstring>(cyhal_pwm_t *obj)</argsstring>
        <name>cyhal_pwm_start</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Starts the PWM generation and outputs on <bold>pin</bold> and <bold>compl_pin</bold>. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PWM object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the start request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="347" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="333" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="333" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pwm_1ga03f475a0f908814996ad697ed3036798" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pwm_stop</definition>
        <argsstring>(cyhal_pwm_t *obj)</argsstring>
        <name>cyhal_pwm_stop</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Stops the PWM generation and outputs on <bold>pin</bold> and <bold>compl_pin</bold>. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PWM object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the stop request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="358" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" bodystart="349" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" line="349" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides a high level interface for interacting with the Cypress PWM. </para>    </briefdescription>
    <detaileddescription>
<para>This is a wrapper around the lower level PDL API.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="53"><highlight class="preprocessor">#include<sp />&lt;string.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="54"><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_clock.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="56"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_gpio.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_hwmgr.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_pwm.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_syspm.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="60"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_utils.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXTCPWM)<sp />||<sp />defined(CY_IP_M0S8TCPWM_INSTANCES)</highlight><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="66"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="67"><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXTCPWM_INSTANCES)</highlight><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_PWM_MAX_WIDTH<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />32</highlight><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_PWM_MAX_WIDTH<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />16</highlight><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_PWM_MAX_DEAD_TIME_CYCLES<sp /><sp /><sp /><sp />255</highlight><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />_CYHAL_PWM_US_PER_SEC<sp />=<sp />1000000u;</highlight></codeline>
<codeline lineno="75"><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXTCPWM)<sp />&amp;&amp;<sp />(CY_IP_MXTCPWM_VERSION<sp />&gt;=<sp />2)</highlight><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="preprocessor">#define<sp />_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED<sp />(_VAL2FLD(TCPWM_GRP_CNT_V2_TR_PWM_CTRL_CC0_MATCH_MODE,<sp />CY_TCPWM_PWM_TR_CTRL2_INVERT)<sp />|<sp />\</highlight></codeline>
<codeline lineno="79"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(TCPWM_GRP_CNT_V2_TR_PWM_CTRL_OVERFLOW_MODE,<sp />CY_TCPWM_PWM_TR_CTRL2_CLEAR)<sp />|<sp />\</highlight></codeline>
<codeline lineno="80"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(TCPWM_GRP_CNT_V2_TR_PWM_CTRL_UNDERFLOW_MODE,<sp />CY_TCPWM_PWM_TR_CTRL2_SET))</highlight><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="82"><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="preprocessor">#define<sp />_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED<sp />(_VAL2FLD(TCPWM_CNT_TR_CTRL2_CC_MATCH_MODE,<sp />CY_TCPWM_PWM_TR_CTRL2_INVERT)<sp />|<sp />\</highlight></codeline>
<codeline lineno="84"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(TCPWM_CNT_TR_CTRL2_OVERFLOW_MODE,<sp />CY_TCPWM_PWM_TR_CTRL2_CLEAR)<sp />|<sp />\</highlight></codeline>
<codeline lineno="85"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(TCPWM_CNT_TR_CTRL2_UNDERFLOW_MODE,<sp />CY_TCPWM_PWM_TR_CTRL2_SET))</highlight><highlight class="normal" /></codeline>
<codeline lineno="86"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />_cyhal_pwm_convert_alignment(<ref kindref="member" refid="group__group__hal__pwm_1ga251111384b543a19975df63353203b51">cyhal_pwm_alignment_t</ref><sp />hal_alignment,<sp />uint32_t<sp />*pdl_alignment,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />swapped)</highlight></codeline>
<codeline lineno="90"><highlight class="normal">{</highlight></codeline>
<codeline lineno="91"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(hal_alignment)</highlight></codeline>
<codeline lineno="92"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="93"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pwm_1gga251111384b543a19975df63353203b51a05ecb08e039afef0513837ce140a3fc1">CYHAL_PWM_LEFT_ALIGN</ref>:</highlight></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*pdl_alignment<sp />=<sp />(swapped)<sp />?<sp />CY_TCPWM_PWM_RIGHT_ALIGN<sp />:<sp />CY_TCPWM_PWM_LEFT_ALIGN;</highlight></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="96"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pwm_1gga251111384b543a19975df63353203b51ae604cf9b7d021f86aff923fe916a8591">CYHAL_PWM_RIGHT_ALIGN</ref>:</highlight></codeline>
<codeline lineno="97"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*pdl_alignment<sp />=<sp />(swapped)<sp />?<sp />CY_TCPWM_PWM_LEFT_ALIGN<sp />:<sp />CY_TCPWM_PWM_RIGHT_ALIGN;</highlight></codeline>
<codeline lineno="98"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="99"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pwm_1gga251111384b543a19975df63353203b51a2d5bca81d542fd2ca4a1348336c67af1">CYHAL_PWM_CENTER_ALIGN</ref>:</highlight></codeline>
<codeline lineno="100"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*pdl_alignment<sp />=<sp />CY_TCPWM_PWM_CENTER_ALIGN;</highlight></codeline>
<codeline lineno="101"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">default</highlight><highlight class="normal">:</highlight></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__results__pwm_1gab7b16a3c46d4332fa511661dedc8d873">CYHAL_PWM_RSLT_BAD_ARGUMENT</ref>;</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="105"><highlight class="normal">}</highlight></codeline>
<codeline lineno="106"><highlight class="normal" /></codeline>
<codeline lineno="107"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />cyhal_pwm_set_period_and_compare(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref><sp />*obj,<sp />uint32_t<sp />period,<sp />uint32_t<sp />compare)</highlight></codeline>
<codeline lineno="108"><highlight class="normal">{</highlight></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(period<sp />&lt;<sp />1<sp />||<sp />period<sp />&gt;<sp />(uint32_t)((1<sp />&lt;&lt;<sp />_CYHAL_TCPWM_DATA[obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>].max_count))<sp />-<sp />1)</highlight></codeline>
<codeline lineno="110"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__results__pwm_1gab7b16a3c46d4332fa511661dedc8d873">CYHAL_PWM_RSLT_BAD_ARGUMENT</ref>;</highlight></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(compare<sp />&gt;=<sp />period)</highlight></codeline>
<codeline lineno="112"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />compare<sp />=<sp />period<sp />-<sp />1;</highlight></codeline>
<codeline lineno="113"><highlight class="normal" /></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref><sp />pin<sp />=<sp />obj-&gt;pin;</highlight></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref><sp />pin_compl<sp />=<sp />obj-&gt;pin_compl;</highlight></codeline>
<codeline lineno="116"><highlight class="normal" /></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_PWM_SetCompare0(obj-&gt;tcpwm.base,<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>,<sp />0u);</highlight></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_PWM_SetPeriod0(obj-&gt;tcpwm.base,<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>,<sp />period<sp />-<sp />1u);</highlight></codeline>
<codeline lineno="119"><highlight class="normal" /></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />swapped_pins<sp />=<sp />(_CYHAL_UTILS_GET_RESOURCE(pin,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga02ba168b99cd9f3d4178b1f3d2e22eee">cyhal_pin_map_tcpwm_line_compl</ref>)<sp />!=<sp />NULL)<sp />&amp;&amp;<sp />(_CYHAL_UTILS_GET_RESOURCE(pin_compl,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga3c9ce6350bc5c02bb97df5040ca8b6e6">cyhal_pin_map_tcpwm_line</ref>)<sp />!=<sp />NULL);</highlight></codeline>
<codeline lineno="121"><highlight class="normal" /></codeline>
<codeline lineno="122"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />defined(CY_IP_MXTCPWM)<sp />&amp;&amp;<sp />(CY_IP_MXTCPWM_VERSION<sp />&gt;=<sp />2)</highlight><highlight class="normal" /></codeline>
<codeline lineno="123"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />pwm_ctrl_reg<sp />=<sp />TCPWM_GRP_CNT_TR_PWM_CTRL(obj-&gt;tcpwm.base,<sp />TCPWM_GRP_CNT_GET_GRP(_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource)),</highlight></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />cc1_ignore_mask<sp />=<sp />(0<sp />==<sp />TCPWM_GRP_CNT_GET_GRP(_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource)))<sp />?</highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0<sp />:<sp />CY_TCPWM_PWM_MODE_CC1_IGNORE;</highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />is_center_aligned<sp />=<sp />(pwm_ctrl_reg<sp />==<sp />(CY_TCPWM_PWM_MODE_CNTR_OR_ASYMM<sp />|<sp />cc1_ignore_mask))<sp />||</highlight></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(pwm_ctrl_reg<sp />==<sp />(_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED<sp />|<sp />cc1_ignore_mask));</highlight></codeline>
<codeline lineno="129"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />is_center_aligned<sp />=<sp />(TCPWM_CNT_TR_CTRL2(obj-&gt;tcpwm.base,<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>)<sp />==<sp />CY_TCPWM_PWM_MODE_CNTR_OR_ASYMM)<sp />||</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(TCPWM_CNT_TR_CTRL2(obj-&gt;tcpwm.base,<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>)<sp />==<sp />_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED);</highlight></codeline>
<codeline lineno="132"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXTCPWM_VERSION<sp />&gt;=<sp />2<sp />or<sp />other<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="133"><highlight class="normal" /></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />new_compare_value<sp />=<sp />(swapped_pins<sp />&amp;&amp;<sp />!is_center_aligned)</highlight></codeline>
<codeline lineno="135"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp />period<sp />-<sp />compare</highlight></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />compare;</highlight></codeline>
<codeline lineno="137"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_PWM_SetCompare0(obj-&gt;tcpwm.base,<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>,<sp />new_compare_value);</highlight></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(Cy_TCPWM_PWM_GetCounter(obj-&gt;tcpwm.base,<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>)<sp />&gt;=<sp />new_compare_value)</highlight></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_TCPWM_PWM_SetCounter(obj-&gt;tcpwm.base,<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>,<sp />0);</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="142"><highlight class="normal" /></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="144"><highlight class="normal">}</highlight></codeline>
<codeline lineno="145"><highlight class="normal" /></codeline>
<codeline lineno="146"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pwm_1gacbeddfe75ccc849d27bec32ce010eceb">cyhal_pwm_init_adv</ref>(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref><sp />pin,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref><sp />pin_compl,<sp /><ref kindref="member" refid="group__group__hal__pwm_1ga251111384b543a19975df63353203b51">cyhal_pwm_alignment_t</ref><sp />pwm_alignment,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />continuous,<sp />uint32_t<sp />dead_time_us,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />invert,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref><sp />*clk)</highlight></codeline>
<codeline lineno="147"><highlight class="normal">{</highlight></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="149"><highlight class="normal" /></codeline>
<codeline lineno="150"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />swapped<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="152"><highlight class="normal" /></codeline>
<codeline lineno="153"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Explicitly<sp />marked<sp />not<sp />allocated<sp />resources<sp />as<sp />invalid<sp />to<sp />prevent<sp />freeing<sp />them.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="154"><highlight class="normal"><sp /><sp /><sp /><sp />memset(obj,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref>));</highlight></codeline>
<codeline lineno="155"><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref>*<sp />map<sp />=<sp />_cyhal_utils_try_alloc(pin,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga3c9ce6350bc5c02bb97df5040ca8b6e6">cyhal_pin_map_tcpwm_line</ref>,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga3c9ce6350bc5c02bb97df5040ca8b6e6">cyhal_pin_map_tcpwm_line</ref>)<sp />/<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref>));</highlight></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(map<sp />==<sp />NULL)</highlight></codeline>
<codeline lineno="158"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />swapped<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />map<sp />=<sp />_cyhal_utils_try_alloc(pin,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga02ba168b99cd9f3d4178b1f3d2e22eee">cyhal_pin_map_tcpwm_line_compl</ref>,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga02ba168b99cd9f3d4178b1f3d2e22eee">cyhal_pin_map_tcpwm_line_compl</ref>)<sp />/<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref>));</highlight></codeline>
<codeline lineno="161"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="162"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(map<sp />==<sp />NULL)</highlight></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__results__pwm_1gab7b16a3c46d4332fa511661dedc8d873">CYHAL_PWM_RSLT_BAD_ARGUMENT</ref>;</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="168"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;tcpwm.resource<sp />=<sp />*map-&gt;<ref kindref="member" refid="structcyhal__resource__pin__mapping__t_1a5c5b6367a94636f9811352bbbc69b1db">inst</ref>;</highlight></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;tcpwm.base<sp />=<sp />_CYHAL_TCPWM_DATA[obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>].base;</highlight></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;pin<sp />=<sp /><ref kindref="member" refid="group__group__hal__gpio_1ga25a61e0d5a27c77dca1c7709fba9c400">CYHAL_NC_PIN_VALUE</ref>;</highlight></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;pin_compl<sp />=<sp /><ref kindref="member" refid="group__group__hal__gpio_1ga25a61e0d5a27c77dca1c7709fba9c400">CYHAL_NC_PIN_VALUE</ref>;</highlight></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />_cyhal_utils_reserve_and_connect(pin,<sp />map);</highlight></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline lineno="174"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;pin<sp />=<sp />pin;</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="178"><highlight class="normal" /></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result<sp />&amp;&amp;<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3dbd1016ea99d087d747530418b89a01">NC</ref><sp />!=<sp />pin_compl)</highlight></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref><sp />*map_compl<sp />=<sp />swapped</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp />_cyhal_utils_get_resource(pin_compl,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga3c9ce6350bc5c02bb97df5040ca8b6e6">cyhal_pin_map_tcpwm_line</ref>,</highlight></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga3c9ce6350bc5c02bb97df5040ca8b6e6">cyhal_pin_map_tcpwm_line</ref>)<sp />/<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref>),<sp />&amp;(obj-&gt;tcpwm.resource))</highlight></codeline>
<codeline lineno="184"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />_cyhal_utils_get_resource(pin_compl,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga02ba168b99cd9f3d4178b1f3d2e22eee">cyhal_pin_map_tcpwm_line_compl</ref>,</highlight></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />sizeof(<ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga02ba168b99cd9f3d4178b1f3d2e22eee">cyhal_pin_map_tcpwm_line_compl</ref>)<sp />/<sp />sizeof(<ref kindref="compound" refid="structcyhal__resource__pin__mapping__t">cyhal_resource_pin_mapping_t</ref>),<sp />&amp;(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="186"><highlight class="normal" /></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((NULL<sp />==<sp />map_compl)<sp />||<sp />!_cyhal_utils_resources_equal(map-&gt;<ref kindref="member" refid="structcyhal__resource__pin__mapping__t_1a5c5b6367a94636f9811352bbbc69b1db">inst</ref>,<sp />map_compl-&gt;<ref kindref="member" refid="structcyhal__resource__pin__mapping__t_1a5c5b6367a94636f9811352bbbc69b1db">inst</ref>))</highlight></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__results__pwm_1gab7b16a3c46d4332fa511661dedc8d873">CYHAL_PWM_RSLT_BAD_ARGUMENT</ref>;</highlight></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />_cyhal_utils_reserve_and_connect(pin_compl,<sp />map_compl);</highlight></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="196"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;pin_compl<sp />=<sp />pin_compl;</highlight></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="198"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="199"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="200"><highlight class="normal" /></codeline>
<codeline lineno="201"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="203"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_M0S8TCPWM_INSTANCES)</highlight><highlight class="normal" /></codeline>
<codeline lineno="204"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />source_hz<sp />=<sp />Cy_SysClk_ClkSysGetFrequency();</highlight></codeline>
<codeline lineno="205"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="206"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />source_hz<sp />=<sp />Cy_SysClk_ClkPeriGetFrequency();</highlight></codeline>
<codeline lineno="207"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="208"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />en_clk_dst_t<sp />pclk<sp />=<sp />(en_clk_dst_t)(_CYHAL_TCPWM_DATA[obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>].clock_dst<sp />+<sp />obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a4488a199114a86e5a72184c7a0a16c06">channel_num</ref>);</highlight></codeline>
<codeline lineno="209"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(NULL<sp />!=<sp />clk)</highlight></codeline>
<codeline lineno="210"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="211"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;tcpwm.clock<sp />=<sp />*clk;</highlight></codeline>
<codeline lineno="212"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_utils_update_clock_format(&amp;obj-&gt;tcpwm.clock);</highlight></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_SYSCLK_SUCCESS<sp />!=<sp />Cy_SysClk_PeriphAssignDivider(pclk,<sp />(cy_en_divider_types_t)obj-&gt;tcpwm.clock.block,<sp />obj-&gt;tcpwm.clock.channel))</highlight></codeline>
<codeline lineno="214"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="215"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__results__pwm_1ga431ab66d01f4897a131ac3569c776fd0">CYHAL_PWM_RSLT_FAILED_CLOCK_INIT</ref>;</highlight></codeline>
<codeline lineno="216"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="218"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />(result<sp />=<sp /><ref kindref="member" refid="group__group__hal__clock_1gaa265dd236fc90f0f90b9776e16991058">cyhal_clock_allocate</ref>(&amp;obj-&gt;tcpwm.clock,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gga1968e793be1599de10dec9e2d48f66d6ad7a5eb2a34cbaf931bf1aaab6f844689">CYHAL_CLOCK_BLOCK_PERIPHERAL_16BIT</ref>)))</highlight></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="220"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;tcpwm.dedicated_clock<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />div<sp />=<sp />(dead_time_us<sp />&gt;<sp />0)</highlight></codeline>
<codeline lineno="222"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />?<sp />(((uint64_t)source_hz<sp />*<sp />dead_time_us)<sp />/<sp />(_CYHAL_PWM_US_PER_SEC<sp />*<sp />_CYHAL_PWM_MAX_DEAD_TIME_CYCLES))<sp />+<sp />1</highlight></codeline>
<codeline lineno="223"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />:<sp />(uint32_t)(1<sp />&lt;&lt;<sp />(_CYHAL_PWM_MAX_WIDTH<sp />-<sp />_CYHAL_TCPWM_DATA[obj-&gt;tcpwm.resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>].max_count));</highlight></codeline>
<codeline lineno="224"><highlight class="normal" /></codeline>
<codeline lineno="225"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(0<sp />==<sp />div<sp />||</highlight></codeline>
<codeline lineno="226"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_SYSCLK_SUCCESS<sp />!=<sp />Cy_SysClk_PeriphSetDivider((cy_en_divider_types_t)obj-&gt;tcpwm.clock.block,<sp />obj-&gt;tcpwm.clock.channel,<sp />div<sp />-<sp />1)<sp />||</highlight></codeline>
<codeline lineno="227"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_SYSCLK_SUCCESS<sp />!=<sp />Cy_SysClk_PeriphEnableDivider((cy_en_divider_types_t)obj-&gt;tcpwm.clock.block,<sp />obj-&gt;tcpwm.clock.channel)<sp />||</highlight></codeline>
<codeline lineno="228"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_SYSCLK_SUCCESS<sp />!=<sp />Cy_SysClk_PeriphAssignDivider(pclk,<sp />(cy_en_divider_types_t)obj-&gt;tcpwm.clock.block,<sp />obj-&gt;tcpwm.clock.channel))</highlight></codeline>
<codeline lineno="229"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__results__pwm_1ga431ab66d01f4897a131ac3569c776fd0">CYHAL_PWM_RSLT_FAILED_CLOCK_INIT</ref>;</highlight></codeline>
<codeline lineno="231"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="232"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="233"><highlight class="normal" /></codeline>
<codeline lineno="234"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="236"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;tcpwm.clock_hz<sp />=<sp /><ref kindref="member" refid="group__group__hal__clock_1gab96248124df045a665fe693801f9a358">cyhal_clock_get_frequency</ref>(&amp;obj-&gt;tcpwm.clock);</highlight></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="238"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="239"><highlight class="normal" /></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />pdl_alignment<sp />=<sp />CY_TCPWM_PWM_LEFT_ALIGN;</highlight></codeline>
<codeline lineno="241"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />_cyhal_pwm_convert_alignment(pwm_alignment,<sp />&amp;pdl_alignment,<sp />swapped);</highlight></codeline>
<codeline lineno="244"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="245"><highlight class="normal" /></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />dead_time<sp />=<sp />(uint8_t)(dead_time_us<sp />*<sp />obj-&gt;tcpwm.clock_hz<sp />/<sp />_CYHAL_PWM_US_PER_SEC);</highlight></codeline>
<codeline lineno="249"><highlight class="normal" /></codeline>
<codeline lineno="250"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_stc_tcpwm_pwm_config_t<sp />config<sp />=</highlight></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="252"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pwmMode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />(dead_time<sp />==<sp />0)<sp />?<sp />CY_TCPWM_PWM_MODE_PWM<sp />:<sp />CY_TCPWM_PWM_MODE_DEADTIME,</highlight></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.clockPrescaler<sp /><sp /><sp /><sp />=<sp />CY_TCPWM_PWM_PRESCALER_DIVBY_1,</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pwmAlignment<sp /><sp /><sp /><sp /><sp /><sp />=<sp />pdl_alignment,</highlight></codeline>
<codeline lineno="255"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.deadTimeClocks<sp /><sp /><sp /><sp />=<sp />dead_time,</highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.runMode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />(continuous)<sp />?<sp />CY_TCPWM_PWM_CONTINUOUS<sp />:<sp />CY_TCPWM_PWM_ONESHOT,</highlight></codeline>
<codeline lineno="257"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.period0<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.period1<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enablePeriodSwap<sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.compare0<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline lineno="261"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.compare1<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableCompareSwap<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline lineno="263"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.interruptSources<sp /><sp />=<sp />CY_TCPWM_INT_NONE,</highlight></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.invertPWMOut<sp /><sp /><sp /><sp /><sp /><sp />=<sp />(invert)<sp />?<sp />CY_TCPWM_PWM_INVERT_ENABLE<sp />:<sp />CY_TCPWM_PWM_INVERT_DISABLE,</highlight></codeline>
<codeline lineno="265"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.invertPWMOutN<sp /><sp /><sp /><sp /><sp />=<sp />(invert)<sp />?<sp />CY_TCPWM_PWM_INVERT_ENABLE<sp />:<sp />CY_TCPWM_PWM_INVERT_DISABLE,</highlight></codeline>
<codeline lineno="266"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.killMode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_PWM_STOP_ON_KILL,</highlight></codeline>
<codeline lineno="267"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.swapInputMode<sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_RISINGEDGE,</highlight></codeline>
<codeline lineno="268"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.swapInput<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_0,</highlight></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.reloadInputMode<sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_RISINGEDGE,</highlight></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.reloadInput<sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_0,</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.startInputMode<sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_RISINGEDGE,</highlight></codeline>
<codeline lineno="272"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.startInput<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_0,</highlight></codeline>
<codeline lineno="273"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.killInputMode<sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_RISINGEDGE,</highlight></codeline>
<codeline lineno="274"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.killInput<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_0,</highlight></codeline>
<codeline lineno="275"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.countInputMode<sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_LEVEL,</highlight></codeline>
<codeline lineno="276"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.countInput<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />CY_TCPWM_INPUT_1</highlight></codeline>
<codeline lineno="277"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="278"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />Cy_TCPWM_PWM_Init(obj-&gt;tcpwm.base,<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource),<sp />&amp;config);</highlight></codeline>
<codeline lineno="279"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((swapped)<sp />&amp;&amp;<sp />(pwm_alignment<sp />==<sp /><ref kindref="member" refid="group__group__hal__pwm_1gga251111384b543a19975df63353203b51a2d5bca81d542fd2ca4a1348336c67af1">CYHAL_PWM_CENTER_ALIGN</ref>))</highlight></codeline>
<codeline lineno="280"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="281"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />defined(CY_IP_MXTCPWM)<sp />&amp;&amp;<sp />(CY_IP_MXTCPWM_VERSION<sp />&gt;=<sp />2)</highlight><highlight class="normal" /></codeline>
<codeline lineno="282"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />cntr_asym_swapped_reg_val<sp />=<sp />(0<sp />==<sp />TCPWM_GRP_CNT_GET_GRP(_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource)))<sp />?</highlight></codeline>
<codeline lineno="283"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Group<sp />0<sp />counters<sp />does<sp />not<sp />have<sp />CC1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="284"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED<sp />:</highlight></codeline>
<codeline lineno="285"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED<sp />|<sp />CY_TCPWM_PWM_MODE_CC1_IGNORE;</highlight></codeline>
<codeline lineno="286"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />TCPWM_GRP_CNT_TR_PWM_CTRL(obj-&gt;tcpwm.base,<sp />TCPWM_GRP_CNT_GET_GRP(_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource)),</highlight></codeline>
<codeline lineno="287"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource))<sp />=<sp />cntr_asym_swapped_reg_val;</highlight></codeline>
<codeline lineno="288"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="289"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />TCPWM_CNT_TR_CTRL2(obj-&gt;tcpwm.base,<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource))<sp />=<sp />_CYHAL_PWM_MODE_CNTR_OR_ASYMM_UO_SWAPPED;</highlight></codeline>
<codeline lineno="290"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXTCPWM_VERSION<sp />&gt;=<sp />2<sp />or<sp />other<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="291"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="292"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="293"><highlight class="normal" /></codeline>
<codeline lineno="294"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline lineno="295"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="296"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_tcpwm_init_data(&amp;obj-&gt;tcpwm);</highlight></codeline>
<codeline lineno="297"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_TCPWM_PWM_Enable(obj-&gt;tcpwm.base,<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="298"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="299"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="300"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="301"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pwm_1ga3e4e8aa7a73d02a15dcf386c335b1598">cyhal_pwm_free</ref>(obj);</highlight></codeline>
<codeline lineno="302"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="303"><highlight class="normal" /></codeline>
<codeline lineno="304"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />result;</highlight></codeline>
<codeline lineno="305"><highlight class="normal">}</highlight></codeline>
<codeline lineno="306"><highlight class="normal" /></codeline>
<codeline lineno="307"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pwm_1ga3e4e8aa7a73d02a15dcf386c335b1598">cyhal_pwm_free</ref>(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="308"><highlight class="normal">{</highlight></codeline>
<codeline lineno="309"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="310"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_utils_release_if_used(&amp;obj-&gt;pin);</highlight></codeline>
<codeline lineno="311"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_utils_release_if_used(&amp;obj-&gt;pin_compl);</highlight></codeline>
<codeline lineno="312"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_tcpwm_free(&amp;obj-&gt;tcpwm);</highlight></codeline>
<codeline lineno="313"><highlight class="normal">}</highlight></codeline>
<codeline lineno="314"><highlight class="normal" /></codeline>
<codeline lineno="315"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pwm_1gaab0dc18eb0b1c51623df07f2c275a578">cyhal_pwm_set_period</ref>(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref><sp />*obj,<sp />uint32_t<sp />period_us,<sp />uint32_t<sp />pulse_width_us)</highlight></codeline>
<codeline lineno="316"><highlight class="normal">{</highlight></codeline>
<codeline lineno="317"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="318"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />period<sp />=<sp />(uint32_t)((uint64_t)period_us<sp />*<sp />obj-&gt;tcpwm.clock_hz<sp />/<sp />_CYHAL_PWM_US_PER_SEC);</highlight></codeline>
<codeline lineno="319"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />width<sp />=<sp />(uint32_t)((uint64_t)pulse_width_us<sp />*<sp />obj-&gt;tcpwm.clock_hz<sp />/<sp />_CYHAL_PWM_US_PER_SEC);</highlight></codeline>
<codeline lineno="320"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />cyhal_pwm_set_period_and_compare(obj,<sp />period,<sp />width);</highlight></codeline>
<codeline lineno="321"><highlight class="normal">}</highlight></codeline>
<codeline lineno="322"><highlight class="normal" /></codeline>
<codeline lineno="323"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pwm_1ga9c468081d85d103ec10f9feeffe416ce">cyhal_pwm_set_duty_cycle</ref>(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref><sp />*obj,<sp /></highlight><highlight class="keywordtype">float</highlight><highlight class="normal"><sp />duty_cycle,<sp />uint32_t<sp />frequencyhal_hz)</highlight></codeline>
<codeline lineno="324"><highlight class="normal">{</highlight></codeline>
<codeline lineno="325"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="326"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(duty_cycle<sp />&lt;<sp />0.0f<sp />||<sp />duty_cycle<sp />&gt;<sp />100.0f<sp />||<sp />frequencyhal_hz<sp />&lt;<sp />1)</highlight></codeline>
<codeline lineno="327"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__results__pwm_1gab7b16a3c46d4332fa511661dedc8d873">CYHAL_PWM_RSLT_BAD_ARGUMENT</ref>;</highlight></codeline>
<codeline lineno="328"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />period<sp />=<sp />obj-&gt;tcpwm.clock_hz<sp />/<sp />frequencyhal_hz;</highlight></codeline>
<codeline lineno="329"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />width<sp />=<sp />(uint32_t)(duty_cycle<sp />*<sp />0.01f<sp />*<sp />period);</highlight></codeline>
<codeline lineno="330"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />cyhal_pwm_set_period_and_compare(obj,<sp />period,<sp />width);</highlight></codeline>
<codeline lineno="331"><highlight class="normal">}</highlight></codeline>
<codeline lineno="332"><highlight class="normal" /></codeline>
<codeline lineno="333"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pwm_1ga95006bcc5841e610719433660365e3e2">cyhal_pwm_start</ref>(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="334"><highlight class="normal">{</highlight></codeline>
<codeline lineno="335"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="336"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(_cyhal_tcpwm_pm_transition_pending())</highlight></codeline>
<codeline lineno="337"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="338"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__results__syspm_1ga562e13ca6ef5662a8c12c5533bb73deb">CYHAL_SYSPM_RSLT_ERR_PM_PENDING</ref>;</highlight></codeline>
<codeline lineno="339"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="340"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_PWM_Enable(obj-&gt;tcpwm.base,<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="341"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />defined(CY_IP_MXTCPWM)<sp />&amp;&amp;<sp />(CY_IP_MXTCPWM_VERSION<sp />&gt;=<sp />2)</highlight><highlight class="normal" /></codeline>
<codeline lineno="342"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_TriggerReloadOrIndex_Single(obj-&gt;tcpwm.base,<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="343"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="344"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_TriggerReloadOrIndex(obj-&gt;tcpwm.base,<sp />1<sp />&lt;&lt;<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="345"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="346"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="347"><highlight class="normal">}</highlight></codeline>
<codeline lineno="348"><highlight class="normal" /></codeline>
<codeline lineno="349"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pwm_1ga03f475a0f908814996ad697ed3036798">cyhal_pwm_stop</ref>(<ref kindref="compound" refid="structcyhal__pwm__t">cyhal_pwm_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="350"><highlight class="normal">{</highlight></codeline>
<codeline lineno="351"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="352"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />defined(CY_IP_MXTCPWM)<sp />&amp;&amp;<sp />(CY_IP_MXTCPWM_VERSION<sp />&gt;=<sp />2)</highlight><highlight class="normal" /></codeline>
<codeline lineno="353"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_TriggerStopOrKill_Single(obj-&gt;tcpwm.base,<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="354"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="355"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_TCPWM_TriggerStopOrKill(obj-&gt;tcpwm.base,<sp />1<sp />&lt;&lt;<sp />_CYHAL_TCPWM_CNT_NUMBER(obj-&gt;tcpwm.resource));</highlight></codeline>
<codeline lineno="356"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="357"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="358"><highlight class="normal">}</highlight></codeline>
<codeline lineno="359"><highlight class="normal" /></codeline>
<codeline lineno="360"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="361"><highlight class="normal">}</highlight></codeline>
<codeline lineno="362"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="363"><highlight class="normal" /></codeline>
<codeline lineno="364"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXTCPWM<sp />*/</highlight><highlight class="preprocessor" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pwm.c" />
  </compounddef>
</doxygen>